/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.PeronaMalikDiffusion;

import org.visnow.jscic.Field;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.filters.PeronaMalikDiffusion.PeronaMalikDiffusionShared.*;

public class GUI extends javax.swing.JPanel
{

    private Parameters parameters; //parameters of a module

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();

    }

    /**
     * Sets parameters of a module
     */
    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;

    }

    /**
     * Updates GUI to represent current status of field/params
     */
    void updateGUI(ParameterProxy p, boolean resetGUIControls)
    {
        int dimNum = p.get(META_NUMBER_OF_DIMENSIONS);

        numericTextField3.setValue(p.get(ITERATION_NUMBER));
        numericTextField4.setValue(p.get(LAMBDA_FOR_ITERATION_SCHEME));// "%.3f");
        numericTextField5.setValue(p.get(PARAMETER_K));//, "%.2f");
        numericTextField14.setValue(p.get(NABLA_WEIGHT_INDEX_I));//, "%.2f");
        numericTextField15.setValue(p.get(NABLA_WEIGHT_INDEX_J));//, "%.2f");
        numericTextField16.setValue(p.get(NABLA_WEIGHT_INDEX_K));//, "%.2f");

        jLabel4.setVisible(dimNum >= 2);
        numericTextField14.setVisible(dimNum >= 2);

        jLabel5.setVisible(dimNum >= 2);
        numericTextField15.setVisible(dimNum >= 2);

        jLabel6.setVisible(dimNum == 3);
        numericTextField16.setVisible(dimNum == 3);

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        numericTextField3 = new org.visnow.vn.gui.components.NumericTextField();
        jLabel2 = new javax.swing.JLabel();
        numericTextField4 = new org.visnow.vn.gui.components.NumericTextField();
        jLabel3 = new javax.swing.JLabel();
        numericTextField5 = new org.visnow.vn.gui.components.NumericTextField();
        jLabel4 = new javax.swing.JLabel();
        numericTextField14 = new org.visnow.vn.gui.components.NumericTextField();
        jLabel5 = new javax.swing.JLabel();
        numericTextField15 = new org.visnow.vn.gui.components.NumericTextField();
        jLabel6 = new javax.swing.JLabel();
        numericTextField16 = new org.visnow.vn.gui.components.NumericTextField();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setLayout(new java.awt.GridBagLayout());

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel1.setText("<html>\ntime iteration \n<br>\nnumber");
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        add(jLabel1, gridBagConstraints);

        numericTextField3.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.INT);
        numericTextField3.setMin(1);
        numericTextField3.setPreferredSize(new java.awt.Dimension(50, 19));
        numericTextField3.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                numericTextField3ValueChangedAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        add(numericTextField3, gridBagConstraints);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel2.setText("<html>\n&lambda proportional \n<br>\nto time step");
        jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        add(jLabel2, gridBagConstraints);

        numericTextField4.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        numericTextField4.setPreferredSize(new java.awt.Dimension(50, 19));
        numericTextField4.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                numericTextField4ValueChangedAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        add(numericTextField4, gridBagConstraints);

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel3.setText("<html>\nconductance \n<br>\nparameter K");
        jLabel3.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        add(jLabel3, gridBagConstraints);

        numericTextField5.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        numericTextField5.setPreferredSize(new java.awt.Dimension(50, 19));
        numericTextField5.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                numericTextField5ValueChangedAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        add(numericTextField5, gridBagConstraints);

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel4.setText("nablaWeightIndexI");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(20, 0, 0, 0);
        add(jLabel4, gridBagConstraints);

        numericTextField14.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        numericTextField14.setPreferredSize(new java.awt.Dimension(50, 19));
        numericTextField14.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                numericTextField14ValueChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(20, 10, 0, 0);
        add(numericTextField14, gridBagConstraints);

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel5.setText("nablaWeightIndexJ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        add(jLabel5, gridBagConstraints);

        numericTextField15.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        numericTextField15.setPreferredSize(new java.awt.Dimension(50, 19));
        numericTextField15.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                numericTextField15ValueChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        add(numericTextField15, gridBagConstraints);

        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel6.setText("nablaWeightIndexK");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        add(jLabel6, gridBagConstraints);

        numericTextField16.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        numericTextField16.setPreferredSize(new java.awt.Dimension(50, 19));
        numericTextField16.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                numericTextField16UserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        add(numericTextField16, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void numericTextField3ValueChangedAction(java.util.EventObject evt) {//GEN-FIRST:event_numericTextField3ValueChangedAction
        // TODO add your handling code here:
        Integer iterationNumber;
        iterationNumber = (Integer) numericTextField3.getValue();
        parameters.set(ITERATION_NUMBER, iterationNumber);

    }//GEN-LAST:event_numericTextField3ValueChangedAction

    private void numericTextField4ValueChangedAction(java.util.EventObject evt)//GEN-FIRST:event_numericTextField4ValueChangedAction
    {//GEN-HEADEREND:event_numericTextField4ValueChangedAction
        // TODO add your handling code here:
        Float lambdaForIterationScheme = (Float) numericTextField4.getValue();
        parameters.set(LAMBDA_FOR_ITERATION_SCHEME, lambdaForIterationScheme);

    }//GEN-LAST:event_numericTextField4ValueChangedAction

    private void numericTextField5ValueChangedAction(java.util.EventObject evt)//GEN-FIRST:event_numericTextField5ValueChangedAction
    {//GEN-HEADEREND:event_numericTextField5ValueChangedAction
        // TODO add your handling code here:
        Float parameterK = (Float) numericTextField5.getValue();
        parameters.set(PARAMETER_K, parameterK);

    }//GEN-LAST:event_numericTextField5ValueChangedAction

    private void numericTextField14ValueChangeAction(java.util.EventObject evt)//GEN-FIRST:event_numericTextField14ValueChangeAction
    {//GEN-HEADEREND:event_numericTextField14ValueChangeAction
        // TODO add your handling code here:
        Float nablaWeightIndexI = (Float) numericTextField14.getValue();
        parameters.set(NABLA_WEIGHT_INDEX_I, nablaWeightIndexI);
    }//GEN-LAST:event_numericTextField14ValueChangeAction

    private void numericTextField15ValueChangeAction(java.util.EventObject evt)//GEN-FIRST:event_numericTextField15ValueChangeAction
    {//GEN-HEADEREND:event_numericTextField15ValueChangeAction
        // TODO add your handling code here:
        Float nablaWeightIndexJ = (Float) numericTextField15.getValue();
        parameters.set(NABLA_WEIGHT_INDEX_J, nablaWeightIndexJ);

    }//GEN-LAST:event_numericTextField15ValueChangeAction

    private void numericTextField16UserChangeAction(java.util.EventObject evt)//GEN-FIRST:event_numericTextField16UserChangeAction
    {//GEN-HEADEREND:event_numericTextField16UserChangeAction
        // TODO add your handling code here:
        Float nablaWeightIndexK = (Float) numericTextField16.getValue();
        parameters.set(NABLA_WEIGHT_INDEX_K, nablaWeightIndexK);
    }//GEN-LAST:event_numericTextField16UserChangeAction

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.Box.Filler filler1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private org.visnow.vn.gui.components.NumericTextField numericTextField14;
    private org.visnow.vn.gui.components.NumericTextField numericTextField15;
    private org.visnow.vn.gui.components.NumericTextField numericTextField16;
    private org.visnow.vn.gui.components.NumericTextField numericTextField3;
    private org.visnow.vn.gui.components.NumericTextField numericTextField4;
    private org.visnow.vn.gui.components.NumericTextField numericTextField5;
    // End of variables declaration//GEN-END:variables
}
